<script lang="ts">
    import type { Application } from "$lib/api/applications";
    import type { CategoryListing } from "$lib/api/categories";
    import type { Playlist } from "$lib/api/playlists";

    import { ApplicationState, listApplications } from "$lib/api/applications";
    import { listCategories } from "$lib/api/categories";
    import { listPlaylists } from "$lib/api/playlists";

    import * as process from "$lib/api/process";
    import Cards from "$lib/Cards.svelte";

    import LinearProgress from "@smui/linear-progress";
    
    function processResolved(resolved: [Application[], Playlist[], CategoryListing[]]) {
        return [
            ...resolved[0].map(process.cardifyApplication), 
            ...resolved[1].map(process.cardifyPlaylist),
            ...resolved[2].map(process.cardifyCategory),
        ];
    }

    const loads = [listApplications({
        current_state: ApplicationState.installed,
        visible: true,
    }), listPlaylists(null, "anonymous"), listCategories()];
</script>

<div>
    <header>
        <h2 class="mdc-typography--headline4">Content</h2>
    </header>

    {#await Promise.all(loads)}
        <LinearProgress indeterminate />
    {:then resolved}
        <Cards
            cards={processResolved(resolved)}
        />
    {/await}
</div>

<style type="text/scss">
    
</style>
